if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

--this module
lib.item = {}
local this = lib.item

this.private = { set = false }

function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.data = {}	
	this.private.data.items = {}
	this.private.data.incomplete = {}
	
	this.private.set = true
end

function this.private.UpdateAll()
	this.private.Validate()
	
	for ID,_ in pairs(this.private.data.incomplete) do
		this.private.UpdateByID(ID)
	end
	return
end
	
function this.private.ConstructLink(ID, Name)
	this.private.Validate()
	
	if(Name == nil) then
		Name = "item:"..ID
	end
    
    local link = {}
	link[1] = "\124cFFA335EE\124Hitem:"
    link[2] = "::::::::110:::::\124h["
    link[3] = "]\124h\124r"
    
    return (link[1]..ID..link[2]..Name..link[3])
end

function this.private.GetBagPositionByID(ItemID)
	for bag = 0, NUM_BAG_SLOTS do
		for slot = 1, GetContainerNumSlots(bag) do
			if(GetContainerItemID(bag, slot) == ItemID) then
				return bag, slot
			end
		end
	end
	return nil
end

function this.UpdateByID(ID, IncludeBagSearch)
	this.private.Validate()
	
	if(this.private.data.items[ID] == nil) then
		lib.chat.error("trying to update item that has not been added: "..ID)
		return
	end
	
	if(this.private.data.incomplete[ID] == nil) then
		return
	end
	
	local itemInfo = { GetItemInfo(ID) }
		
	if(itemInfo[1] ~= nil) then
		this.private.data.items[ID].name = itemInfo[1]
		this.private.data.items[ID].link = itemInfo[2]
		
		this.private.data.incomplete[ID] = nil
	end
	
	if(IncludeBagSearch == true) then
		local Bag, Slot = this.private.GetBagPositionByID(ID)
		if(Bag ~= nil and Slot ~= nil) then
			this.private.data.items[ID].BagLink = GetContainerItemLink(Bag, Slot)
		end
	end		
	return
end

function this.AddByID(ID)
	this.private.Validate()
	
	--it is allowed to add the same item multiple times because several modules could ask for the same item data!
	if(this.private.data.items[ID] ~= nil) then
		return false
	end	
	
	this.private.data.items[ID] = 
	{
		name = "item:"..ID,
		link = this.private.ConstructLink(ID)
	}
	
	this.private.data.incomplete[ID] = true

	this.UpdateByID(ID)
	return true
end

function this.GetByID(ID)
	this.private.Validate()

	if(this.private.data.items[ID] == nil) then
		lib.chat.error("trying to access item that has not been added: "..ID)
		return nil
	end
	
	if(this.private.data.incomplete[ID] == true) then
		this.UpdateByID(ID)
	end
		
	return this.private.data.items[ID]
end
