if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

lib.lockout = {}
local this = lib.lockout

this.private = { set = false }

function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.data = {}
	this.private.data.worldbosses = {}
	this.private.data.instances = {}
	
	this.private.set = true
end

this.instance = {}
this.worldboss = {}
this.lfg = {}

function this.requestUpdate()
	this.private.Validate()
	
	RequestRaidInfo()
	this.private.localUpdate()
	return
end

function this.private.localUpdate()
	this.private.Validate()

	this.private.data.instances = nil
	this.private.data.instances = {}
	local numInst = 0
	local numSavedInst = GetNumSavedInstances()
	for i=1,numSavedInst do
		local instInfo = {GetSavedInstanceInfo(i)}
		if(instInfo[5] == true) then --we are only interested in active locks
			numInst = numInst + 1
			
			--print(i, numInst, instInfo[1])
			
			this.private.data.instances[numInst] = {}
			local inst = this.private.data.instances[numInst]
			inst.name = instInfo[1]
			inst.diff = instInfo[4]
			inst.chatLink = GetSavedInstanceChatLink(i)
			inst.numBosses = instInfo[11]
			inst.allBossesKilled = true
			inst.bosses = {}
			for j=1, inst.numBosses do
				local savedBossInfo = {GetSavedInstanceEncounterInfo(i,j)}
				inst.bosses[j] = {}
				inst.bosses[j].name = savedBossInfo[1]
				inst.bosses[j].isKilled = savedBossInfo[3]
				if(savedBossInfo[3] == false) then
					inst.allBossesKilled = false
				end
			end
		end
	end
	
	this.private.data.worldbosses = nil
	this.private.data.worldbosses = {}
	local numWB = GetNumSavedWorldBosses()
	for i=1, numWB do
		local WBInfo = {GetSavedWorldBossInfo(i)}
		this.private.data.worldbosses[WBInfo[2]] = true
	end
	
	return
end

function this.instance.getByJournalId(journalId, diff)
	this.private.Validate()
	
	--savedInstInfo only exposes a name, no ID that would be of any use to us.
	--we will retrieve the name of the instance by journalID and use that for comparison
	
	local name = lib.journal.instance.getNameById(journalId)
	
	--try exact match first
	for _,lockout in pairs(this.private.data.instances) do
		if(lockout.name == name) then
			if((diff == nil) or (diff == lockout.diff)) then
				return lockout
			end
		end
	end
	
	--now try containment
	for _,lockout in pairs(this.private.data.instances) do
		f,_ = string.find(lockout.name, name)
		if(f ~= nil) then
			if((diff == nil) or (diff == lockout.diff)) then
				return lockout
			end
		end
	end
	
	return nil
end

function this.worldboss.getByIndex(index)
	this.private.validate()
	
	if(this.private.data.worldbosses[index] == nil) then
		return false
	else
		return true
	end
end

function this.lfg.isBossKilled(lfg)
	local bossInfo = {GetLFGDungeonEncounterInfo(lfg.id, lfg.bossIndex)}
	if(bossInfo == nil) then
		lib.chat.error("failed to get LFG encounter info")
	end
	return bossInfo[3]
end
