if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

--this module
lib.map = {}
local this = lib.map

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.ContinentMapType = 2
	
	this.private.set = true
end

function this.GetNameByID(ID)
	this.private.Validate()
	
	local MapInfo = C_Map.GetMapInfo(ID)
		
	return MapInfo.name
end

function this.GetTypeByID(ID)
	this.private.Validate()
	
	local MapInfo = C_Map.GetMapInfo(ID)
		
	return MapInfo.mapType
end

function this.GetParentIDByID(ID)
	this.private.Validate()
	
	local MapInfo = C_Map.GetMapInfo(ID)
		
	return MapInfo.parentMapID
end

function this.GetContinentIDByID(ID)
	this.private.Validate()
	
	local MapInfo = C_Map.GetMapInfo(ID)
	
	if(MapInfo.mapType < this.private.ContinentMapType) then
		return nil
	elseif(MapInfo.mapType == this.private.ContinentMapType) then
		return ID
	else
		while(MapInfo.mapType > (this.private.ContinentMapType+1)) do
			MapInfo = C_Map.GetMapInfo(MapInfo.parentMapID)
		end
		return MapInfo.parentMapID
	end
end

function this.GetCurrentMapID()
	this.private.Validate()
	
	local MapID = C_Map.GetBestMapForUnit("player")
	return MapID
end

function this.IsSameContinent(MapA, MapB)
	this.private.Validate()
	
	if(MapB == nil) then
		MapB = this.GetCurrentMapID()
	end
	
	--most obvious case
	if(MapA == MapB) then
		return true
	end
	
	--all "continents" are mapType = 2
	--so to find out if two maps are on the same continent we simply have to go up their parents until
	--Type 2 and compare those
	
	local ContinentA = this.GetContinentIDByID(MapA)
	local ContinentB = this.GetContinentIDByID(MapB)
	
	--print(ContinentA.name, ContinentB.name)
	return (ContinentA == ContinentB)
end

function this.GetMyContinent()
	this.private.Validate()
	
	local MyMapID = this.GetCurrentMapID()
	
	return this.GetNameByID(this.GetContinentIDByID(this.GetCurrentMapID()))
end

function this.GetMapGenealogy(MapID, Delimiter)
	this.private.Validate()
	
	if(Delimiter == nil) then
		Delimiter = " >> "
	end
	
	if(this.GetTypeByID(MapID) <= this.private.ContinentMapType) then
		return this.GetNameByID(MapID)
	end
	
	local Index = 1
	local Genealogy = { [Index] = MapID }
	local CurrentMapID = MapID
	while(this.GetTypeByID(CurrentMapID) > this.private.ContinentMapType) do
		CurrentMapID = this.GetParentIDByID(CurrentMapID)
		Index = Index+1
		Genealogy[Index] = CurrentMapID
	end
	
	local GenealogyString = this.GetNameByID(Genealogy[Index])
	Index = Index-1
	
	while(Index > 0) do
		GenealogyString = GenealogyString..Delimiter..this.GetNameByID(Genealogy[Index])
		Index = Index-1
	end
	
	return GenealogyString
end
