if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.BFABonusRoll = {}
local this = ttd2.BFABonusRoll
this.name = "BFABonusRoll"

this.private = { set = false }

function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.Quests =
	{
		52837, 52840,	--Vendor: OHR
		52834, 52838,	--Vendor: Gold
		52835, 52839	--Vendor: PVP
	}

	this.private.Currency =
	{
		ID			= 1580, --BFA bonusroll currency
		WeeklyMax	= 2,
	}
	
	for _,QuestID in pairs(this.private.Quests) do
		lib.quest.AddByID(QuestID)
	end
	
	lib.currency.AddByID(this.private.Currency.ID)
	
	return
end

function this.Update()
	this.private.Validate()
	
	for _,QuestID in pairs(this.private.Quests) do
		lib.quest.UpdateByID(QuestID)
	end
	
	lib.currency.UpdateByID(this.private.Currency.ID)
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	local CurrencyData = lib.currency.GetByID(this.private.Currency.ID)
	
	local Traded = 0
	for _,QuestID in pairs(this.private.Quests) do
		if(lib.quest.GetByID(QuestID).isCompleted == true) then
			Traded = Traded+1
		end		
	end
	
	if((Traded < this.private.Currency.WeeklyMax) and (CurrencyData.Amount < CurrencyData.TotalMax)) then
		out.StoreTodo(CurrencyData.Link..lib.chat.yellow(" "..Traded.." / "..this.private.Currency.WeeklyMax))
	elseif(Traded == this.private.Currency.WeeklyMax) then
		out.StoreCompleted(CurrencyData.Link..lib.chat.green(" "..Traded.." / "..this.private.Currency.WeeklyMax))
	else
		out.StoreDone(CurrencyData.Link..lib.chat.yellow(" "..Traded.." / "..this.private.Currency.WeeklyMax).." traded, but at cap of "..lib.chat.red(CurrencyData.Amount.." / "..CurrencyData.TotalMax))
	end
	return
end

function this.Print()
	this.private.Validate()
	
	local out = lib.chat.output
	out.PrintModule(this.name)
	
	return
end

this.private.Text = this.name
function this.private.Script()
	this.private.Validate()
	
	this.Update()
	this.Print()
	
	return
end

mod[#mod+1] =
{
	Text = this.private.Text,
	Script = this.private.Script
}


--[[if(ThingsToDo == nil) then
	ThingsToDo = {}
end
local ttd = ThingsToDo
if(ttd.mod == nil) then
	ttd.mod = {}
end
local mod = ttd.mod

local lib = ttd.lib

--this module
mod.bonusRoll = {}
local this = mod.bonusRoll

this.private = { set = false }
function this.private.validate()
	if(this.private.set == false) then
		lib.chat.error("used without init: mod.bonusRoll")
	end
	return
end

function this.private.init()
	if(this.private.set) then
		lib.chat.error("init called more than once: mod.bonusRoll")
	end

	this.private.quests =
	{
		43892, 43893, 43894, --Vendor: OHR
		43895, 43896, 43897, --Vendor: Gold
		47851, 47864, 47864, --Vendor: PVP
		47040, 47045, 47054, --Netherdisruptor
		43510 --OH Mission
	}

	this.private.currency =
	{
		id = 1273, --legion bonusroll currency
		weeklyMax = 3,
		traded = 0
	}
	
	this.private.outputReady = false
	
	this.private.set = true
end

function this.requestUpdate()
	this.private.validate()
	
	lib.currency.updateById(this.private.currency.id)
	
	local traded = 0
	for _,id in pairs(this.private.quests) do
		lib.quest.updateById(id)
		if(lib.quest.getById(id).isCompleted) then
			traded = traded + 1
		end
	end
	
	this.private.currency.traded = traded
	
	this.private.outputReady = true
	return
end

this.output = {}

function this.output.isReady()
	this.private.validate()
	
	return this.private.outputReady
end

function this.output.generate()
	this.private.validate()
	
	if(this.output.status == false) then
		lib.chat.error("BonusRoll: genereateOutput() called before ready")
		return false
	end
	
    local message =
	{
		status = {},
		text = lib.currency.getLinkById(this.private.currency.id)
	}
	
    if(this.private.currency.traded < this.private.currency.weeklyMax) then
        if(lib.currency.getAmountById(this.private.currency.id) == lib.currency.getTotalMaxById(this.private.currency.id)) then
            message.text = message.text..lib.chat.red("("..
            lib.currency.getAmountById(this.private.currency.id).." / "..lib.currency.getTotalMaxById(this.private.currency.id)..")")
        end
        
        message.status.done = false
        message.text = message.text..": "..
        this.private.currency.traded.." / "..this.private.currency.weeklyMax
    else
        message.status.done = true
        message.text = message.text..": "..
        lib.chat.green(this.private.currency.traded.." / "..this.private.currency.weeklyMax)
    end
    
    lib.messageQueue.addMessage(message)
    return true
end

function this.init(moduleContainer)
	this.private.init()
	moduleContainer[#moduleContainer + 1] =
	{
		name = "bonusRoll",
		requestUpdate = this.requestUpdate,
		isOutputReady = this.output.isReady,
		generateOutput = this.output.generate
		
	}
end--]]
