if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.BFAKeystone = {}
local this = ttd2.BFAKeystone
this.name = "BFAKeystone"

this.private = { set = false }

function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.KeystoneItemID = 158923
	
	--this.private.MaxRewardLevel = lib.keystone.GetMaxRewardLevel()
	this.private.CurrentCompletedLevel = nil
	this.private.OwnedKeystoneLink = nil
	this.private.IsRewardAvailable = nil

	lib.item.AddByID(this.private.KeystoneItemID)
	lib.item.UpdateByID(this.private.KeystoneItemID, true)
	
	return
end

function this.Update()
	this.private.Validate()
	
	lib.item.UpdateByID(this.private.KeystoneItemID, true)
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	if(UnitLevel("player") < 120) then
		out.StoreTodo("Get to "..lib.chat.yellow("level 120").." to access M+ dungeons!")
		return
	end
	
	--link stone
	if(lib.item.GetByID(this.private.KeystoneItemID).BagLink ~= nil) then
		out.StoreDone("Your Keystone: "..lib.item.GetByID(this.private.KeystoneItemID).BagLink)
	end
	
	--test if last week reward is collected
	if(lib.keystone.IsRewardChestAvailable() == true) then
		out.StoreTodo("Collect your "..lib.chat.green("Reward-Chest").." for last week!")
	else
		out.StoreDone("Reward-Chest for last week already collected/not available.")
	end
	
	--test current week M+ completed
	local CurrentBest = lib.keystone.GetCurrentWeekBest()
	if(CurrentBest < lib.keystone.GetMaxRewardLevel()) then
		out.StoreTodo("Completed: "..lib.chat.yellow(CurrentBest)..", Reward caps at: "..lib.chat.green(lib.keystone.GetMaxRewardLevel()))
	else
		out.StoreCompleted("Completed: "..lib.chat.green(CurrentBest))
	end
	
	return
end

function this.Print()
	this.private.Validate()
	
	local out = lib.chat.output
	out.PrintModule(this.name)
	
	return
end

this.private.Text = this.name
function this.private.Script()
	this.private.Validate()
	
	this.Update()
	this.Print()
	
	return
end

mod[#mod+1] =
{
	Text = this.private.Text,
	Script = this.private.Script
}
