if(ThingsToDo == nil) then
	ThingsToDo = {}
end
local ttd = ThingsToDo

if(ttd.mod == nil) then
	ttd.mod = {}
end
local mod = ttd.mod

local lib = ttd.lib

--this module
mod.mounts = {}
local this = mod.mounts

this.output = {}

this.private = { set = false }

function this.private.validate()
	if(this.private.set == false) then
		lib.chat.error("used without init: mod.mounts")
	end
	return
end

function this.private.init()
	if(this.private.set) then
		lib.chat.error("init called more than once: mod.mounts")
	end
	
	this.private.mounts = {}
	this.private.mounts.farmable = 	{
		{
			--Drone: blau
			journalId = 117, itemId = 21218,
			src = 
			{
				inst = 
				{
					journalId = 744,
					diff = { modes = { 9 } },
					extraInfo = "trashdrop"
				}
			}
		},
		{
			--Drone: grün
			journalId = 120, itemId = 21323,
			src = 
			{
				inst = 
				{
					journalId = 744,
					diff = { modes = { 9 } },
					extraInfo = "trashdrop"
				}
			}
		},
		{
			--Drone: gelb
			journalId = 119, itemId = 21324,
			src = 
			{
				inst = 
				{
					journalId = 744,
					diff = { modes = { 9 } },
					extraInfo = "trashdrop"
				}
			}
		},
		{
			--Drone: rot
			journalId = 118, itemId = 21321,
			src = 
			{
				inst = 
				{
					journalId = 744,
					diff = { modes = { 9 } },
					extraInfo = "trashdrop"
				}
			}
		},
		{
			--Todesstreitross
			journalId = 69, itemId = 13335,
			src = 
			{
				inst = 
				{
					journalId = 236,
					diff = { modes = { 1 } }
				},                
				enc = { journalId = 456 }
			}
		},
		{
			--Vitriolsteindrache
			journalId = 397, itemId = 63043,
			src = 
			{
				inst = 
				{
					journalId = 67,
					diff = { modes = { 1 } }
				},                
				enc = { journalId = 111 }
			}
		},
		{
			--Drache des Nordwinds
			journalId = 395, itemId = 63040,
			src = 
			{
				inst = 
				{
					journalId = 68,
					diff = { modes = { 1 } }
				},                
				enc = { journalId = 115 }
			}
		}
	}
	this.private.mounts.worldboss = {
		{
			--himmlische onyxwolkenschlange
			journalId = 473, itemId = 87771,
			src = 
			{
				inst = 
				{
					journalId = 322,
					diff = { modes = { 4 } }
				},                
				enc = { journalId = 691, index = 1 },
				bonusRoll = 697
			}
		},
		{
			--sohn von galleon
			journalId = 515, itemId = 89783,
			src = 
			{
				inst = 
				{
					journalId = 322,
					diff = { modes = { 4 } }
				},                
				enc = { journalId = 725, index = 2 },
				bonusRoll = 697
			}
		},
		{
			--Donnernde Kobaltschlange
			journalId = 542, itemId = 95057,
			src = 
			{
				inst = 
				{
					journalId = 322,
					diff = { modes = { 4 } }
				},                
				enc = { journalId = 814, index = 3 },
				bonusRoll = 752
			}
		},
		{
			--Kobaltblaues Urterrorhorn
			journalId = 533, itemId = 94228,
			src = 
			{
				inst = 
				{
					journalId = 322,
					diff = { modes = { 4 } }
				},                
				enc = { journalId = 826, index = 4 },
				bonusRoll = 752
			}
		},
		{
			--Sonnenfalke der Spitzen
			journalId = 634, itemId = 116771,
			src = 
			{
				inst = 
				{
					journalId = 557,
					diff = { modes = { 14 } }
				},                
				enc = { journalId = 1262, index = 9 }
			}
		}
	}
	this.private.mounts.archavon = {
		{
			--Schwarzes Kriegsmammut - Allianz
			journalId = 286, itemId = 43959,
			src = 
			{
				inst = 
				{
					journalId = 753,
					diff = { modes = { 4, 3 } }
				}
			},
			faction = "Alliance"
		},
		{
			--Schwarzes Kriegsmammut - Horde            
			journalId = 287, itemId = 44083,
			src = 
			{
				inst = 
				{
					journalId = 753,
					diff = { modes = { 4, 3 } }
				}
			},
			faction = "Horde"
		}
	}
	this.private.mounts.timerun = {
		{
			--Bronzedrache
			journalId = 248, itemId = 43951,
			src = 
			{
				inst = 
				{
					journalId = 279,
					diff = { strict = true, modes = { 2 } },
					extraInfo = "timerun"
				}
			}
		},
		{
			--Amani Kriegsbär
			journalId = 419, itemId = 69747,
			src = 
			{
				inst = 
				{
					journalId = 77,
					diff = { strict = true, modes = { 2 } },
					extraInfo = "timerun"
				}
			}
		},
		{
			--Glimmender Glutwyrm
			journalId = 883, itemId = 142552,
			src = 
			{
				inst = 
				{
					journalId = 860,
					diff = { strict = true, modes = { 23 } },
					extraInfo = "timerun"
				},                
				enc = { index = 9 }
			}
		}
	}
	this.private.mounts.oldLockoutBoss = {
		{
			--Weisser Falkenschreiter
			journalId = 213, itemId = 35513,
			src = 
			{
				inst = 
				{
					journalId = 249,
					diff = { strict = true, modes = { 2 } }
				},                
				enc = { journalId = 533, index = 1 }
			}
		},
		{
			--Rabenfürst
			journalId = 185, itemId = 32768,
			src = 
			{
				inst = 
				{
					journalId = 252,
					diff = { strict = true, modes = { 2 } }
				},                
				enc = { journalId = 542, index = 3 }
			}
		},
		{
			--Blauer Protodrache
			journalId = 264, itemId = 44151,
			src = 
			{
				inst = 
				{
					journalId = 286,
					diff = { strict = true, modes = { 2 } }
				},                
				enc = { journalId = 643, index = 3 }
			}
		},
		{
			--Zulianischer Panther
			journalId = 411, itemId = 68824,
			src = 
			{
				inst = 
				{
					journalId = 76,
					diff = { strict = true, modes = { 2 } }
				},                
				enc = { journalId = 181, index = 4 }
			}
		},
		{
			--Razzashiraptor
			journalId = 410, itemId = 68823,
			src = 
			{
				inst = 
				{
					journalId = 76,
					diff = { strict = true, modes = { 2 } }
				},                
				enc = { journalId = 176, index = 2 }
			}
		},
		{
			--Feuriges Schlachtross
			journalId = 168, itemId = 30480,
			src=
			{
				inst =
				{
					journalId = 745,
					diff = { modes = { 3 } }
				},
				enc = { journalId = 1553, index=1 }
			}
		},
		{
			--Al'ars Asche
			journalId = 183, itemId = 32458,
			src = 
			{
				inst = 
				{
					journalId = 749,
					diff = { modes = { 4 } }
				},                
				enc = { journalId = 1576, index = 4 }
			},
		},
		{
			--Azurblauer Drache
			journalId = 246, itemId = 43952,
			src = 
			{
				inst = 
				{
					journalId = 756,
					diff = { modes = { 4, 3 } }
				},                
				enc = { journalId = 1617, index = 1 }
			}
		},
		{
			--Blaudrache
			journalId = 247, itemId = 43953,
			src = 
			{
				inst = 
				{
					journalId = 756,
					diff = { modes = { 4, 3 } }
				},                
				enc = { journalId = 1617, index = 1 }
			}
		},
		{
			--Schwarzer Drache
			journalId = 253, itemId = 43986,
			src = 
			{
				inst = 
				{
					journalId = 755,
					diff = { strict = true, modes = { 3 } }
				},                
				enc = { journalId = 1616, index = 4, extraInfo = "+3" }
			}
		},
		{
			--Zwielichtdrache
			journalId = 250, itemId = 43954,
			src = 
			{
				inst = 
				{
					journalId = 755,
					diff = { strict = true, modes = { 4 } }
				},                
				enc = { journalId = 1616, index = 4, extraInfo = "+3" }
			}
		},
		{
			--Drache von Onyxia
			journalId = 349, itemId = 49636,
			src = 
			{
				inst = 
				{
					journalId = 760,
					diff = { modes = { 4, 3 } }
				},                
				enc = { journalId = 1651, index = 1 }
			}
		},
		{
			--Mimirons Kopf
			journalId = 304, itemId = 45693,
			src = 
			{
				inst = 
				{
					journalId = 759,
					diff = { strict = true, modes = { 4 } }
				},                
				enc = { journalId = 1649, index = 16, extraInfo = "+0" }
			}
		},
		{
			--Unbesiegbar
			journalId = 363, itemId = 50818,
			src = 
			{
				inst = 
				{
					journalId = 758,
					diff = { strict = true, modes = { 6 } }
				},                
				enc = { journalId = 1636, index = 12 }
			}
		},
		{
			--Drache des Südwinds
			journalId = 396, itemId = 63041,
			src = 
			{
				inst = 
				{
					journalId = 74,
					diff = { modes = { 6, 5, 4, 3 } }
				},                
				enc = { journalId = 155, index = 2 }
			}
		},
		{
			--Flammenkralle von Alysrazar
			journalId = 425, itemId = 71665,
			src = 
			{
				inst = 
				{
					journalId = 78,
					diff = { modes = { 6, 5, 4, 3 } }
				},                
				enc = { journalId = 194, index = 4 }
			}
		},
		{
			--Reinblut Feuerfalke
			journalId = 417, itemId = 69224,
			src = 
			{
				inst = 
				{
					journalId = 78,
					diff = { modes = { 6, 5, 4, 3 } }
				},                
				enc = { journalId = 198, index = 7 }
			}
		},
		{
			--Experiment 12-B
			journalId = 445, itemId = 78919,
			src = 
			{
				inst = 
				{
					journalId = 187,
					diff = { modes = { 6, 5, 4, 3 } }
				},                
				enc = { journalId = 331, index = 5 }
			}
		},
		{
			--Lodernder Drache
			journalId = 442, itemId = 77067,
			src = 
			{
				inst = 
				{
					journalId = 187,
					diff = { modes = { 6, 5, 4, 3 } }
				},                
				enc = { journalId = 333, index = 8 }
			}
		},
		{
			--Erste Dame
			journalId = 444, itemId = 77069,
			src = 
			{
				inst = 
				{
					journalId = 187,
					diff = { strict = true, modes = { 6, 5 } }
				},                
				enc = { journalId = 333, index = 8 }
			}
		},
		{
			--Astrale Wolkenschlange
			journalId = 478, itemId = 87777,
			src = 
			{
				inst = 
				{
					journalId = 317,
					diff = { modes = { 6, 5, 4, 3 } }
				},                
				enc = { journalId = 726, index = 5 }
			}
		},
		{
			--Ausgeburt von Horridon
			journalId = 531, itemId = 93666,
			src = 
			{
				inst = 
				{
					journalId = 362,
					diff = { modes = { 6, 5, 4, 3 } }
				},                
				enc = { journalId = 819, index = 2 }
			}
		},
		{
			--Kralle von Ji-Kun
			journalId = 543, itemId = 95059,
			src = 
			{
				inst = 
				{
					journalId = 362,
					diff = { modes = { 6, 5, 4, 3 } }
				},                
				enc = { journalId = 828, index = 6 }
			}
		}
	}
	this.private.mounts.newLockoutBoss = {
		{
			--Koloss der Kor'kron
			journalId = 559, itemId = 104253,
			src = 
			{
				inst = 
				{
					journalId = 369,
					diff = { strict = true, modes = { 16 } }
				}, 
				enc = { journalId = 869, index = 14 }
			}
		},
		{
			--Eisenhufzerstörer
			journalId = 613, itemId = 116660,
			src = 
			{
				inst = 
				{
					journalId = 457,
					diff = { strict = true, modes = { 16 } }
				},                
				enc = { journalId = 959, index = 10 }
			}
		},
		{
			--Teufelsstahlvernichter
			journalId = 751, itemId = 123890,
			src = 
			{
				inst = 
				{
					journalId = 669,
					diff = { strict = true, modes = { 16 } }
				},                
				enc = { journalId = 1438, index = 13 }
			}
		},		
		{
			--Mittnacht
			journalId = 875, itemId = 142236,
			src = 
			{
				inst = 
				{
					journalId = 860,
					diff = { strict = true, modes = { 23 } }
				},                
				enc = { journalId = 1835, index = 4 }
			}
		},
		{
			--Teufelsfeuerhöllenbestie
			journalId = 791, itemId = 137574,
			src = 
			{
				inst = 
				{
					journalId = 786,
					diff = { strict = true, modes = { 16, 15, 14 } }
				},                
				enc = { journalId = 1737, index = 10 }
			}
		},
		{
			--Höllenfeuerbestie
			journalId = 633, itemId = 137575,
			src = 
			{
				inst = 
				{
					journalId = 786,
					diff = { strict = true, modes = { 16 } }
				},                
				enc = { journalId = 1737, index = 10 }
			}
		},
		{
			--Kluftwurm
			journalId = 899, itemId = 143643,
			src = 
			{
				inst = 
				{
					journalId = 875,
					diff = { strict = true, modes = { 16, 15, 14 } }
				},
				enc = { journalId = 1861, index = 5 },
				lfg = { id = 1494, bossIndex = 3, diff = 17 }
			}
		},
		{
			--Aschenhund
			journalId = 971, itemId = 152816,
			src = 
			{
				inst = 
				{
					journalId = 946,
					diff = { strict = true, modes = { 16, 15, 14 } }
				},                
				enc = { journalId = 1987, index = 2 },
				lfg = { id = 1610, bossIndex = 2, diff = 17 }
			}
		}
	}
	
	this.private.outputReady = false
	
	this.private.set = true
end

function this.requestUpdate()
	this.private.validate()
	
	for _,mount in pairs(this.private.mounts.farmable) do
		lib.journal.mount.updateById(mount.journalId)
		lib.item.addById(mount.itemId)
	end
	
	for _,mount in pairs(this.private.mounts.worldboss) do
		lib.journal.mount.updateById(mount.journalId)
		lib.item.addById(mount.itemId)
	end
	
	for _,mount in pairs(this.private.mounts.archavon) do
		lib.journal.mount.updateById(mount.journalId)
		lib.item.addById(mount.itemId)
	end
	
	for _,mount in pairs(this.private.mounts.timerun) do
		lib.journal.mount.updateById(mount.journalId)
		lib.item.addById(mount.itemId)
	end
	
	for _,mount in pairs(this.private.mounts.oldLockoutBoss) do
		lib.journal.mount.updateById(mount.journalId)
		lib.item.addById(mount.itemId)
	end
	
	for _,mount in pairs(this.private.mounts.newLockoutBoss) do
		lib.journal.mount.updateById(mount.journalId)
		lib.item.addById(mount.itemId)
	end
	
	this.private.outputReady = true
	return
end

function this.output.isReady()
	this.private.validate()

	return this.private.outputReady
end

function this.output.generate()
	this.private.validate()

	if(this.output.isReady() == false) then
		lib.chat.error("mod.mounts: output.generate() called before ready")
		return false
	end
	
	for i,_ in pairs(this.private.mounts.farmable) do
		this.private.printFarmable(i)
	end
	
	for i,_ in pairs(this.private.mounts.worldboss) do
		this.private.printWorldboss(i)
	end
	
	for i,_ in pairs(this.private.mounts.archavon) do
		this.private.printArchavon(i)
	end
	
	for i,_ in pairs(this.private.mounts.timerun) do
		this.private.printTimerun(i)
	end
	
	for i,_ in pairs(this.private.mounts.oldLockoutBoss) do
		this.private.printOldLockoutBoss(i)
	end
	
	for i,_ in pairs(this.private.mounts.newLockoutBoss) do
		this.private.printNewLockoutBoss(i)
	end
		
	return
end

function this.init(moduleContainer)
	this.private.init()
	moduleContainer[#moduleContainer + 1] =
	{
		name = "mounts",
		requestUpdate = this.requestUpdate,
		isOutputReady = this.output.isReady,
		generateOutput = this.output.generate
	}
	return
end

function this.private.instLink(inst,diff)
	if(inst == nil) then
		return nil
	end
	
	local instLink = lib.journal.instance.getLinkByIdDiff(inst.journalId, diff)
	local strictDiff = nil
	if(inst.diff.strict == true) then
		strictDiff = lib.journal.instance.getDiffText(diff)
	end
	local extraInfo = nil
	if(inst.extraInfo ~= nil) then
		extraInfo = inst.extraInfo
	end
	
	if( (strictDiff ~= nil) and (extraInfo ~= nil) ) then
		return instLink..lib.chat.yellow("("..strictDiff..", "..extraInfo..")")
	elseif( (strictDiff ~= nil) and (extraInfo == nil) ) then
		return instLink..lib.chat.yellow("("..strictDiff..")")
	elseif( (strictDiff == nil) and (extraInfo ~= nil) ) then
		return instLink..lib.chat.yellow("("..extraInfo..")")
	else
		return instLink
	end
end

function this.private.encLink(enc,diff)
	if(enc == nil) then
		return nil
	end
	
	local encLink = lib.journal.encounter.getLinkByIdDiff(enc.journalId, diff)
	--local extraInfo = nil
	
	if(enc.extraInfo ~= nil) then
		return encLink..lib.chat.yellow("("..enc.extraInfo..")")
	else
		return encLink
	end
end

function this.private.printFarmable(index)
	this.private.validate()
	
	--[[Farmable mounts are the easiest case.]]
	
	local mount = this.private.mounts.farmable[index]
	
	if(mount == nil) then
		lib.chat.error("invalid index supplied to printFarmable()")
		return
	end
	
	local message =
	{
		status = { collected = lib.journal.mount.getById(mount.journalId).isCollected },
		text = lib.chat.track(
			lib.item.getById(mount.itemId).link,
			this.private.encLink(mount.src.enc,mount.src.inst.diff.modes[1]),
			this.private.instLink(mount.src.inst,mount.src.inst.diff.modes[1]))
	}
	
	lib.messageQueue.addMessage(message)
	
	return
end

function this.private.printWorldboss(index)
	this.private.validate()
	
	--[[worldbosses are special because their saved info is much simpler than that of instances.]]
	
	local mount = this.private.mounts.worldboss[index]
	
	if(mount == nil) then
		lib.chat.error("invalid index supplied to printWorldboss()")
		return
	end
	
	local bonusLink = nil
	if(mount.src.bonusRoll ~= nil) then
		bonusLink = lib.currency.getLinkById(mount.src.bonusRoll)
	end
	
	local lockout = lib.lockout.worldboss.getByIndex(mount.src.enc.index)
	
	local message =
	{
		status = 
		{
			collected = lib.journal.mount.getById(mount.journalId).isCollected,
			done = lockout
		},
		text = lib.chat.track(
			lib.item.getById(mount.itemId).link,
			this.private.encLink(mount.src.enc,mount.src.inst.diff.modes[1]),
			bonusLink)
	}
	
	lib.messageQueue.addMessage(message)
	
	return
end

function this.private.printArchavon(index)
	this.private.validate()
	
	--[[Archavons Vault is special because the mount can dropp off all 4 bosses and is faction specific.]]
	
	local mount = this.private.mounts.archavon[index]
	
	if(mount == nil) then
		lib.chat.error("invalid index supplied to printArchavon()")
		return
	end
	
	local myFaction = UnitFactionGroup("player")
	if(mount.faction ~= myFaction) then
		return --wrong faction, skip
	end
	
	local lockout = lib.lockout.instance.getByJournalId(mount.src.inst.journalId)
	
	local message =
	{
		status = 
		{
			collected = lib.journal.mount.getById(mount.journalId).isCollected,
			done = ((lockout ~= nil) and (lockout.allBossesKilled == true))
		},
		text = nil
	}
	
	if(lockout == nil) then
		message.text = lib.chat.track(
			lib.item.getById(mount.itemId).link,
			this.private.instLink(mount.src.inst,mount.src.inst.diff.modes[1]))
	else
		message.text = lib.chat.track(
			lib.item.getById(mount.itemId).link,
			lockout.chatLink)
	end

	lib.messageQueue.addMessage(message)

	return
end

function this.private.printTimerun(index)
	this.private.validate()
	
	--[[currently there are 3 timerun mounts:
	- zul'aman bear
	- stratholme dragon
	- karazhan(5) dragon
	all three of these dungeons only have one saveable lockout; so we do not need to check for a valid diff match.]]
	
	local mount = this.private.mounts.timerun[index]
	
	if(mount == nil) then
		lib.chat.error("invalid index supplied to printTimerun()")
		return
	end
	
	local lockout = lib.lockout.instance.getByJournalId(mount.src.inst.journalId)
	
	local message =
	{
		status = 
		{
			collected = lib.journal.mount.getById(mount.journalId).isCollected,
			done = (lockout ~= nil)
		},
		text = nil
	}
	
	if(lockout == nil) then
		message.text = lib.chat.track(
			lib.item.getById(mount.itemId).link,
			this.private.instLink(mount.src.inst,mount.src.inst.diff.modes[1]))
	else
		message.text = lib.chat.track(
			lib.item.getById(mount.itemId).link,
			lockout.chatLink)
	end

	lib.messageQueue.addMessage(message)

	return
end

function this.private.printOldLockoutBoss(index)
	this.private.validate()
	
	--for this lockout type, there is only ONE saved lockout per character; we need to check if the diff matches!
	
	local mount = this.private.mounts.oldLockoutBoss[index]
	
	if(mount == nil) then
		lib.chat.error("invalid index supplied to printOldLockoutBoss()")
		return
	end
	
	local lockout = lib.lockout.instance.getByJournalId(mount.src.inst.journalId)
	
	local message =
	{
		status = 
		{
			collected = lib.journal.mount.getById(mount.journalId).isCollected,
			done = ((lockout ~= nil) and (lockout.bosses[mount.src.enc.index].isKilled == true))
		},
		text = nil
	}
	
	if(lockout == nil) then
		message.text = lib.chat.track(
			lib.item.getById(mount.itemId).link,
			this.private.encLink(mount.src.enc,mount.src.inst.diff.modes[1]),
			this.private.instLink(mount.src.inst,mount.src.inst.diff.modes[1]))
	else
		local chatLink = lockout.chatLink
		if( (mount.src.inst.diff.strict == true) and (mount.src.inst.diff.modes[1] ~= lockout.diff) ) then
			chatLink = lib.chat.track(
				this.private.instLink(mount.src.inst,mount.src.inst.diff.modes[1]),
				chatLink..lib.chat.red("("..lib.journal.instance.getDiffText(lockout.diff)..")"))
		end
		
		message.text = lib.chat.track(
			lib.item.getById(mount.itemId).link,
			chatLink)
	end

	lib.messageQueue.addMessage(message)

	return
end

function this.private.printNewLockoutBossDiff(mount, diff)
	this.private.validate()
	
	local lockout = lib.lockout.instance.getByJournalId(mount.src.inst.journalId, diff) --we only care about this specific difficulty!
	
	local message =
	{
		status = 
		{
			done = ((lockout ~= nil) and (lockout.bosses[mount.src.enc.index].isKilled == true))
		},
		text = nil
	}
	
	if(lockout == nil) then
		message.text = lib.chat.track(
			lib.item.getById(mount.itemId).link,
			this.private.encLink(mount.src.enc,diff),
			this.private.instLink(mount.src.inst,diff))
	else
		message.text = lib.chat.track(
			lib.item.getById(mount.itemId).link,
			lockout.chatLink)
	end

	lib.messageQueue.addMessage(message)
	
	return
end

function this.private.printNewLockoutBossLfg(mount, lfg)
	this.private.validate()
		
	local message =
	{
		status = { done = lib.lockout.lfg.isBossKilled(lfg) },
		text = lib.chat.track(
			lib.item.getById(mount.itemId).link,
			this.private.encLink(mount.src.enc,lfg.diff),
			this.private.instLink(mount.src.inst,lfg.diff))
	}
	
	lib.messageQueue.addMessage(message)
	
	return
end

function this.private.printNewLockoutBoss(index)
	this.private.validate()
	
	--for this lockout type, there is one saved lockout per difficulty, which means we need to find matches
	
	local mount = this.private.mounts.newLockoutBoss[index]
	
	if(mount == nil) then
		lib.chat.error("invalid index supplied to printNewLockoutBoss()")
		return
	end
	
	if(lib.journal.mount.getById(mount.journalId).isCollected == true) then
		--print simple collected message
		local message =
		{
			status = { collected = true },
			text = lib.chat.track(
				lib.item.getById(mount.itemId).link,
				this.private.encLink(mount.src.enc,mount.src.inst.diff.modes[1]),
				this.private.instLink(mount.src.inst,mount.src.inst.diff.modes[1]))
		}
	else
		--check each difficulty
		for _,diff in pairs(mount.src.inst.diff.modes) do
			this.private.printNewLockoutBossDiff(mount, diff)
		end
		if(mount.src.lfg ~= nil) then
			this.private.printNewLockoutBossLfg(mount, mount.src.lfg)
		end
	end

	return
end
